VTK: vtkCurveRepresentation Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkCurveRepresentation Class Referenceabstract

base class for a widget that represents a curve that connects control points. More...

`#include <vtkCurveRepresentation.h>`

Inheritance diagram for vtkCurveRepresentation:
[legend]
Collaboration diagram for vtkCurveRepresentation:
[legend]

## Public Types
enum | InteractionStateType { Outside = 0 , OnHandle , OnLine , Moving , Scaling , Spinning , Inserting , Erasing , Pushing }
typedef vtkWidgetRepresentation | Superclass
typedef InteractionStateType | _InteractionState
Public Types inherited from vtkWidgetRepresentation
enum | Axis { NONE = -1 , XAxis = 0 , YAxis = 1 , ZAxis = 2 , Custom = 3 }
| Axis labels. More...
typedef vtkProp | Superclass
| Standard methods for instances of this class. More...
Public Types inherited from vtkProp
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for instances of this class. More...
vtkCurveRepresentation * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetPlaneSource (vtkPlaneSource *plane)
| Set up a reference to a vtkPlaneSource that could be from another widget object, e.g. More...
virtual void | SetProjectionNormal (int)
virtual int | GetProjectionNormal ()
void | SetProjectionNormalToXAxes ()
void | SetProjectionNormalToYAxes ()
void | SetProjectionNormalToZAxes ()
void | SetProjectionNormalToOblique ()
virtual void | GetPolyData (vtkPolyData *pd)=0
| Grab the polydata (including points) that defines the interpolating curve. More...
vtkTypeBool | IsClosed ()
| Convenience method to determine whether the curve is closed in a geometric sense. More...
virtual double | GetSummedLength ()=0
| Get the approximate vs. More...
virtual void | InitializeHandles (vtkPoints *points)=0
| Convenience method to allocate and set the handles from a vtkPoints instance. More...
void | SetLineColor (double r, double g, double b)
| Convenience method to set the line color. More...
void | RegisterPickers () override
| Register internal Pickers in the Picking Manager. More...
void | GetActors (vtkPropCollection *) override
| Methods to make this class behave as a vtkProp. More...
virtual void | SetInteractionState (int)
| Set the interaction state. More...
virtual void | SetProjectToPlane (vtkTypeBool)
| Force the widget to be projected onto one of the orthogonal planes. More...
virtual vtkTypeBool | GetProjectToPlane ()
| Force the widget to be projected onto one of the orthogonal planes. More...
virtual void | ProjectToPlaneOn ()
| Force the widget to be projected onto one of the orthogonal planes. More...
virtual void | ProjectToPlaneOff ()
| Force the widget to be projected onto one of the orthogonal planes. More...
void | SetProjectionPosition (double position)
| Set the position of poly line handles and points in terms of a plane's position. More...
virtual double | GetProjectionPosition ()
| Set the position of poly line handles and points in terms of a plane's position. More...
virtual vtkProperty * | GetHandleProperty ()
| Set/Get the handle properties (the spheres are the handles). More...
virtual vtkProperty * | GetSelectedHandleProperty ()
| Set/Get the handle properties (the spheres are the handles). More...
virtual vtkProperty * | GetLineProperty ()
| Set/Get the line properties. More...
virtual vtkProperty * | GetSelectedLineProperty ()
| Set/Get the line properties. More...
virtual void | SetNumberOfHandles (int npts)=0
| Set/Get the number of handles for this widget. More...
virtual int | GetNumberOfHandles ()
| Set/Get the number of handles for this widget. More...
virtual void | SetDirectional (bool val)
| Set the representation to be directional or not. More...
virtual bool | GetDirectional ()
| Set the representation to be directional or not. More...
virtual void | DirectionalOn ()
| Set the representation to be directional or not. More...
virtual void | DirectionalOff ()
| Set the representation to be directional or not. More...
virtual void | SetHandlePosition (int handle, double x, double y, double z)
| Set/Get the position of the handles. More...
virtual void | SetHandlePosition (int handle, double xyz[3])
| Set/Get the position of the handles. More...
virtual void | GetHandlePosition (int handle, double xyz[3])
| Set/Get the position of the handles. More...
virtual double * | GetHandlePosition (int handle)
| Set/Get the position of the handles. More...
virtual vtkDoubleArray * | GetHandlePositions ()=0
| Set/Get the position of the handles. More...
void | SetClosed (vtkTypeBool closed)
| Control whether the curve is open or closed. More...
virtual vtkTypeBool | GetClosed ()
| Control whether the curve is open or closed. More...
virtual void | ClosedOn ()
| Control whether the curve is open or closed. More...
virtual void | ClosedOff ()
| Control whether the curve is open or closed. More...
void | BuildRepresentation () override=0
| These are methods that satisfy vtkWidgetRepresentation API. More...
int | ComputeInteractionState (int X, int Y, int modify=0) override
| These are methods that satisfy vtkWidgetRepresentation API. More...
void | StartWidgetInteraction (double e[2]) override
| These are methods that satisfy vtkWidgetRepresentation API. More...
void | WidgetInteraction (double e[2]) override
| These are methods that satisfy vtkWidgetRepresentation API. More...
void | EndWidgetInteraction (double e[2]) override
| These are methods that satisfy vtkWidgetRepresentation API. More...
double * | GetBounds () override
| These are methods that satisfy vtkWidgetRepresentation API. More...
void | ReleaseGraphicsResources (vtkWindow *) override
| Methods supporting, and required by, the rendering process. More...
int | RenderOpaqueGeometry (vtkViewport *) override
| Methods supporting, and required by, the rendering process. More...
int | RenderTranslucentPolygonalGeometry (vtkViewport *) override
| Methods supporting, and required by, the rendering process. More...
int | RenderOverlay (vtkViewport *) override
| Methods supporting, and required by, the rendering process. More...
vtkTypeBool | HasTranslucentPolygonalGeometry () override
| Methods supporting, and required by, the rendering process. More...
void | SetInteractionColor (double, double, double)
| Set the color when unselected and selected. More...
void | SetInteractionColor (double c[3])
| Set the color when unselected and selected. More...
void | SetForegroundColor (double, double, double)
| Set the color when unselected and selected. More...
void | SetForegroundColor (double c[3])
| Set the color when unselected and selected. More...
void | SetCurrentHandleIndex (int index)
| Get/Set the current handle index. More...
virtual int | GetCurrentHandleIndex ()
| Get/Set the current handle index. More...
virtual int | GetTranslationAxis ()
| Gets/Sets the constraint axis for translations. More...
virtual void | SetTranslationAxis (int)
| Gets/Sets the constraint axis for translations. More...
void | SetXTranslationAxisOn ()
| Toggles constraint translation axis on/off. More...
void | SetYTranslationAxisOn ()
| Toggles constraint translation axis on/off. More...
void | SetZTranslationAxisOn ()
| Toggles constraint translation axis on/off. More...
void | SetTranslationAxisOff ()
| Toggles constraint translation axis on/off. More...
bool | IsTranslationConstrained ()
| Returns true if ConstrainedAxis. More...
Public Member Functions inherited from vtkWidgetRepresentation
virtual void | PlaceWidget (double vtkNotUsed(bounds)[6])
| The following is a suggested API for widget representations. More...
virtual int | GetInteractionState ()
virtual void | Highlight (int vtkNotUsed(highlightOn))
double * | GetBounds () override
| Methods to make this class behave as a vtkProp. More...
void | ShallowCopy (vtkProp *prop) override
| Shallow copy of this vtkProp. More...
void | GetActors (vtkPropCollection *) override
| For some exporters and other other operations we must be able to collect all the actors or volumes. More...
void | GetActors2D (vtkPropCollection *) override
void | GetVolumes (vtkPropCollection *) override
void | ReleaseGraphicsResources (vtkWindow *) override
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE Release any graphics resources that are being consumed by this actor. More...
int | RenderOverlay (vtkViewport *vtkNotUsed(viewport)) override
int | RenderOpaqueGeometry (vtkViewport *vtkNotUsed(viewport)) override
int | RenderTranslucentPolygonalGeometry (vtkViewport *vtkNotUsed(viewport)) override
int | RenderVolumetricGeometry (vtkViewport *vtkNotUsed(viewport)) override
vtkTypeBool | HasTranslucentPolygonalGeometry () override
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop have some translucent polygonal geometry? This method is called during the rendering process to know if there is some translucent polygonal geometry. More...
virtual void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
| Enable/Disable the use of a manager to process the picking. More...
void | SetPickingManaged (bool managed)
| Enable/Disable the use of a manager to process the picking. More...
virtual bool | GetPickingManaged ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | SetRenderer (vtkRenderer *ren)
| Subclasses of vtkWidgetRepresentation must implement these methods. More...
virtual vtkRenderer * | GetRenderer ()
| Subclasses of vtkWidgetRepresentation must implement these methods. More...
virtual void | StartComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual void | ComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual void | EndComplexInteraction (vtkRenderWindowInteractor *, vtkAbstractWidget *, unsigned long, void *)
virtual int | ComputeComplexInteractionState (vtkRenderWindowInteractor *iren, vtkAbstractWidget *widget, unsigned long event, void *callData, int modify=0)
virtual void | SetPlaceFactor (double)
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual double | GetPlaceFactor ()
| Set/Get a factor representing the scaling of the widget upon placement (via the PlaceWidget() method). More...
virtual void | SetHandleSize (double)
| Set/Get the factor that controls the size of the handles that appear as part of the widget (if any). More...
virtual double | GetHandleSize ()
| Set/Get the factor that controls the size of the handles that appear as part of the widget (if any). More...
virtual vtkTypeBool | GetNeedToRender ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | SetNeedToRender (vtkTypeBool)
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | NeedToRenderOn ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
virtual void | NeedToRenderOff ()
| Some subclasses use this data member to keep track of whether to render or not (i.e., to minimize the total number of renders). More...
vtkWidgetRepresentation * | NewInstance () const
| Standard methods for instances of this class. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for instances of this class. More...
Public Member Functions inherited from vtkProp
vtkProp * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | Pick ()
| Method fires PickEvent if the prop is picked. More...
virtual vtkMTimeType | GetRedrawMTime ()
| Return the mtime of anything that would cause the rendered image to appear differently. More...
virtual void | PokeMatrix (vtkMatrix4x4 *vtkNotUsed(matrix))
| These methods are used by subclasses to place a matrix (if any) in the prop prior to rendering. More...
virtual vtkMatrix4x4 * | GetMatrix ()
virtual bool | HasKeys (vtkInformation *requiredKeys)
| Tells if the prop has all the required keys. More...
virtual int | RenderVolumetricGeometry (vtkViewport *)
virtual bool | RenderFilteredOpaqueGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the opaque geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredTranslucentPolygonalGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the translucent polygonal geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredVolumetricGeometry (vtkViewport *v, vtkInformation *requiredKeys)
| Render the volumetric geometry only if the prop has all the requiredKeys. More...
virtual bool | RenderFilteredOverlay (vtkViewport *v, vtkInformation *requiredKeys)
| Render in the overlay of the viewport only if the prop has all the requiredKeys. More...
virtual vtkTypeBool | HasOpaqueGeometry ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS Does this prop have some opaque geometry? This method is called during the rendering process to know if there is some opaque geometry. More...
virtual double | GetEstimatedRenderTime (vtkViewport *)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS The EstimatedRenderTime may be used to select between different props, for example in LODProp it is used to select the level-of-detail. More...
virtual double | GetEstimatedRenderTime ()
virtual void | SetEstimatedRenderTime (double t)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS This method is used by, for example, the vtkLODProp3D in order to initialize the estimated render time at start-up to some user defined value. More...
virtual void | RestoreEstimatedRenderTime ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THESE METHODS OUTSIDE OF THE RENDERING PROCESS When the EstimatedRenderTime is first set to 0.0 (in the SetAllocatedRenderTime method) the old value is saved. More...
virtual void | AddEstimatedRenderTime (double t, vtkViewport *vtkNotUsed(vp))
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS This method is intended to allow the renderer to add to the EstimatedRenderTime in props that require information that the renderer has in order to do this. More...
void | SetRenderTimeMultiplier (double t)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Get/Set the multiplier for the render time. More...
virtual double | GetRenderTimeMultiplier ()
virtual void | BuildPaths (vtkAssemblyPaths *paths, vtkAssemblyPath *path)
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Used to construct assembly paths and perform part traversal. More...
virtual bool | GetSupportsSelection ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS Used by vtkHardwareSelector to determine if the prop supports hardware selection. More...
virtual void | ProcessSelectorPixelBuffers (vtkHardwareSelector *, std::vector< unsigned int > &)
| allows a prop to update a selections color buffers More...
virtual void | SetVisibility (vtkTypeBool)
| Set/Get visibility of this vtkProp. More...
virtual vtkTypeBool | GetVisibility ()
| Set/Get visibility of this vtkProp. More...
virtual void | VisibilityOn ()
| Set/Get visibility of this vtkProp. More...
virtual void | VisibilityOff ()
| Set/Get visibility of this vtkProp. More...
virtual void | SetPickable (vtkTypeBool)
| Set/Get the pickable instance variable. More...
virtual vtkTypeBool | GetPickable ()
| Set/Get the pickable instance variable. More...
virtual void | PickableOn ()
| Set/Get the pickable instance variable. More...
virtual void | PickableOff ()
| Set/Get the pickable instance variable. More...
virtual void | SetDragable (vtkTypeBool)
| Set/Get the value of the dragable instance variable. More...
virtual vtkTypeBool | GetDragable ()
| Set/Get the value of the dragable instance variable. More...
virtual void | DragableOn ()
| Set/Get the value of the dragable instance variable. More...
virtual void | DragableOff ()
| Set/Get the value of the dragable instance variable. More...
virtual void | SetUseBounds (bool)
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual bool | GetUseBounds ()
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual void | UseBoundsOn ()
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual void | UseBoundsOff ()
| In case the Visibility flag is true, tell if the bounds of this prop should be taken into account or ignored during the computation of other bounding boxes, like in vtkRenderer::ResetCamera(). More...
virtual void | InitPathTraversal ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual vtkAssemblyPath * | GetNextPath ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual int | GetNumberOfPaths ()
| vtkProp and its subclasses can be picked by subclasses of vtkAbstractPicker (e.g., vtkPropPicker). More...
virtual vtkInformation * | GetPropertyKeys ()
| Set/Get property keys. More...
virtual void | SetPropertyKeys (vtkInformation *keys)
| Set/Get property keys. More...
virtual void | SetAllocatedRenderTime (double t, vtkViewport *vtkNotUsed(v))
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS The renderer may use the allocated rendering time to determine how to render this actor. More...
virtual double | GetAllocatedRenderTime ()
| WARNING: INTERNAL METHOD - NOT INTENDED FOR GENERAL USE DO NOT USE THIS METHOD OUTSIDE OF THE RENDERING PROCESS. More...
virtual int | GetNumberOfConsumers ()
| Get the number of consumers. More...
void | AddConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
void | RemoveConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
vtkObject * | GetConsumer (int i)
| Add or remove or get or check a consumer,. More...
int | IsConsumer (vtkObject *c)
| Add or remove or get or check a consumer,. More...
virtual void | SetShaderProperty (vtkShaderProperty *property)
| Set/Get the shader property. More...
virtual vtkShaderProperty * | GetShaderProperty ()
| Set/Get the shader property. More...
virtual bool | IsRenderingTranslucentPolygonalGeometry ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCurveRepresentation * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkWidgetRepresentation
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for instances of this class. More...
static vtkWidgetRepresentation * | SafeDownCast (vtkObjectBase *o)
| Standard methods for instances of this class. More...
Static Public Member Functions inherited from vtkProp
static vtkTypeBool | IsTypeOf (const char *type)
static vtkProp * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | GeneralTextureUnit ()
| Optional Key Indicating the texture unit for general texture mapping Old OpenGL was a state machine where you would push or pop items. More...
static vtkInformationDoubleVectorKey * | GeneralTextureTransform ()
| Optional Key Indicating the texture transform for general texture mapping Old OpenGL was a state machine where you would push or pop items. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for instances of this class. More...
| vtkCurveRepresentation ()
| ~vtkCurveRepresentation () override
void | ProjectPointsToPlane ()
void | ProjectPointsToOrthoPlane ()
void | ProjectPointsToObliquePlane ()
void | HighlightLine (int highlight)
int | HighlightHandle (vtkProp *prop)
virtual vtkActor * | GetHandleActor (int index)=0
virtual vtkHandleSource * | GetHandleSource (int index)=0
virtual int | GetHandleIndex (vtkProp *prop)=0
| returns handle index or -1 on fail More...
virtual void | SizeHandles ()
virtual int | InsertHandleOnLine (double *pos)=0
| Returns the position of insertion or -1 on fail. More...
virtual void | PushHandle (double *pos)
virtual void | EraseHandle (const int &)
void | MovePoint (double *p1, double *p2)
void | Scale (double *p1, double *p2, int X, int Y)
void | Translate (double *p1, double *p2)
void | Spin (double *p1, double *p2, double *vpn)
void | CreateDefaultProperties ()
void | CalculateCentroid ()
Protected Member Functions inherited from vtkWidgetRepresentation
| vtkWidgetRepresentation ()
| ~vtkWidgetRepresentation () override
void | AdjustBounds (double bounds[6], double newBounds[6], double center[3])
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the widget representation currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the registered picker, and return the assembly path. More...
vtkAssemblyPath * | GetAssemblyPath3DPoint (double pos[3], vtkAbstractPropPicker *picker)
bool | NearbyEvent (int X, int Y, double bounds[6])
double | SizeHandlesRelativeToViewport (double factor, double pos[3])
double | SizeHandlesInPixels (double factor, double pos[3])
void | UpdatePropPose (vtkProp3D *prop, const double *pos1, const double *orient1, const double *pos2, const double *orient2)
Protected Member Functions inherited from vtkProp
| vtkProp ()
| ~vtkProp () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | LastEventPosition [3]
double | Bounds [6]
int | ProjectionNormal
double | ProjectionPosition
vtkTypeBool | ProjectToPlane
vtkPlaneSource * | PlaneSource
int | NumberOfHandles = 0
vtkTypeBool | Closed
vtkActor * | LineActor
vtkCellPicker * | HandlePicker
vtkCellPicker * | LinePicker
double | LastPickPosition [3]
vtkActor * | CurrentHandle
int | CurrentHandleIndex
bool | FirstSelected
vtkTransform * | Transform
bool | Directional = false
vtkProperty * | HandleProperty
vtkProperty * | SelectedHandleProperty
vtkProperty * | LineProperty
vtkProperty * | SelectedLineProperty
double | Centroid [3]
int | TranslationAxis
Protected Attributes inherited from vtkWidgetRepresentation
vtkWeakPointer< vtkRenderer > | Renderer
int | InteractionState
double | StartEventPosition [3]
double | PlaceFactor
int | Placed
double | InitialBounds [6]
double | InitialLength
int | ValidPick
bool | PickingManaged
double | HandleSize
vtkTypeBool | NeedToRender
vtkTimeStamp | BuildTime
vtkNew< vtkTransform > | TempTransform
vtkNew< vtkMatrix4x4 > | TempMatrix
Protected Attributes inherited from vtkProp
vtkTypeBool | Visibility
vtkTypeBool | Pickable
vtkTypeBool | Dragable
bool | UseBounds
double | AllocatedRenderTime
double | EstimatedRenderTime
double | SavedEstimatedRenderTime
double | RenderTimeMultiplier
int | NumberOfConsumers
vtkObject ** | Consumers
vtkAssemblyPaths * | Paths
vtkInformation * | PropertyKeys
vtkShaderProperty * | ShaderProperty
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

base class for a widget that represents a curve that connects control points.

Base class for widgets used to define curves from points, such as vtkPolyLineRepresentation and vtkSplineRepresentation. This class uses handles, the number of which can be changed, to represent the points that define the curve. The handles can be picked can be picked on the curve itself to translate or rotate it in the scene.

See also
  vtkPolyLineRepresentation vtkSplineRepresentation

Definition at line 42 of file vtkCurveRepresentation.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkWidgetRepresentation vtkCurveRepresentation::Superclass

Definition at line 45 of file vtkCurveRepresentation.h.

## ◆ _InteractionState

typedef InteractionStateType vtkCurveRepresentation::_InteractionState

Definition at line 63 of file vtkCurveRepresentation.h.

## Member Enumeration Documentation

## ◆ InteractionStateType

enum vtkCurveRepresentation::InteractionStateType

Enumerator
Outside |
OnHandle |
OnLine |
Moving |
Scaling |
Spinning |
Inserting |
Erasing |
Pushing |

Definition at line 49 of file vtkCurveRepresentation.h.

## Constructor & Destructor Documentation

## ◆ vtkCurveRepresentation()

vtkCurveRepresentation::vtkCurveRepresentation | ( |  | ) |
| protected

## ◆ ~vtkCurveRepresentation()

vtkCurveRepresentation::~vtkCurveRepresentation | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkCurveRepresentation::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkCurveRepresentation::IsA | ( | const char * | type | ) |
| virtual

Standard methods for instances of this class.

Reimplemented from vtkWidgetRepresentation.

Reimplemented in vtkSplineRepresentation, vtkPolyLineRepresentation, vtkCameraPathRepresentation, and vtkAbstractSplineRepresentation.

## ◆ SafeDownCast()

static vtkCurveRepresentation* vtkCurveRepresentation::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCurveRepresentation::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for instances of this class.

Reimplemented from vtkWidgetRepresentation.

Reimplemented in vtkSplineRepresentation, vtkPolyLineRepresentation, vtkCameraPathRepresentation, and vtkAbstractSplineRepresentation.

## ◆ NewInstance()

vtkCurveRepresentation* vtkCurveRepresentation::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkCurveRepresentation::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkSplineRepresentation, and vtkPolyLineRepresentation.

## ◆ SetInteractionState()

virtual void vtkCurveRepresentation::SetInteractionState | ( | int |  | ) |
| virtual

Set the interaction state.

## ◆ SetProjectToPlane()

virtual void vtkCurveRepresentation::SetProjectToPlane | ( | vtkTypeBool |  | ) |
| virtual

Force the widget to be projected onto one of the orthogonal planes.

Remember that when the InteractionState changes, a ModifiedEvent is invoked. This can be used to snap the curve to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ GetProjectToPlane()

virtual vtkTypeBool vtkCurveRepresentation::GetProjectToPlane | ( |  | ) |
| virtual

Force the widget to be projected onto one of the orthogonal planes.

Remember that when the InteractionState changes, a ModifiedEvent is invoked. This can be used to snap the curve to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ ProjectToPlaneOn()

virtual void vtkCurveRepresentation::ProjectToPlaneOn | ( |  | ) |
| virtual

Force the widget to be projected onto one of the orthogonal planes.

Remember that when the InteractionState changes, a ModifiedEvent is invoked. This can be used to snap the curve to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ ProjectToPlaneOff()

virtual void vtkCurveRepresentation::ProjectToPlaneOff | ( |  | ) |
| virtual

Force the widget to be projected onto one of the orthogonal planes.

Remember that when the InteractionState changes, a ModifiedEvent is invoked. This can be used to snap the curve to the plane if it is originally not aligned. The normal in SetProjectionNormal is 0,1,2 for YZ,XZ,XY planes respectively and 3 for arbitrary oblique planes when the widget is tied to a vtkPlaneSource.

## ◆ SetPlaneSource()

void vtkCurveRepresentation::SetPlaneSource | ( | vtkPlaneSource * | plane | ) |

Set up a reference to a vtkPlaneSource that could be from another widget object, e.g.

a vtkPolyDataSourceWidget.

## ◆ SetProjectionNormal()

virtual void vtkCurveRepresentation::SetProjectionNormal | ( | int |  | ) |
| virtual

## ◆ GetProjectionNormal()

virtual int vtkCurveRepresentation::GetProjectionNormal | ( |  | ) |
| virtual

## ◆ SetProjectionNormalToXAxes()

void vtkCurveRepresentation::SetProjectionNormalToXAxes | ( |  | ) |
| inline

Definition at line 96 of file vtkCurveRepresentation.h.

## ◆ SetProjectionNormalToYAxes()

void vtkCurveRepresentation::SetProjectionNormalToYAxes | ( |  | ) |
| inline

Definition at line 97 of file vtkCurveRepresentation.h.

## ◆ SetProjectionNormalToZAxes()

void vtkCurveRepresentation::SetProjectionNormalToZAxes | ( |  | ) |
| inline

Definition at line 98 of file vtkCurveRepresentation.h.

## ◆ SetProjectionNormalToOblique()

void vtkCurveRepresentation::SetProjectionNormalToOblique | ( |  | ) |
| inline

Definition at line 99 of file vtkCurveRepresentation.h.

## ◆ SetProjectionPosition()

void vtkCurveRepresentation::SetProjectionPosition | ( | double | position | ) |

Set the position of poly line handles and points in terms of a plane's position.

i.e., if ProjectionNormal is 0, all of the x-coordinate values of the points are set to position. Any value can be passed (and is ignored) to update the poly line points when Projection normal is set to 3 for arbitrary plane orientations.

## ◆ GetProjectionPosition()

virtual double vtkCurveRepresentation::GetProjectionPosition | ( |  | ) |
| virtual

Set the position of poly line handles and points in terms of a plane's position.

i.e., if ProjectionNormal is 0, all of the x-coordinate values of the points are set to position. Any value can be passed (and is ignored) to update the poly line points when Projection normal is set to 3 for arbitrary plane orientations.

## ◆ GetPolyData()

virtual void vtkCurveRepresentation::GetPolyData | ( | vtkPolyData * | pd | ) |
| pure virtual

Grab the polydata (including points) that defines the interpolating curve.

Points are guaranteed to be up-to-date when either the InteractionEvent or EndInteraction events are invoked. The user provides the vtkPolyData and the points and polyline are added to it.

Implemented in vtkPolyLineRepresentation, and vtkAbstractSplineRepresentation.

## ◆ GetHandleProperty()

virtual vtkProperty* vtkCurveRepresentation::GetHandleProperty | ( |  | ) |
| virtual

Set/Get the handle properties (the spheres are the handles).

The properties of the handles when selected and unselected can be manipulated.

## ◆ GetSelectedHandleProperty()

virtual vtkProperty* vtkCurveRepresentation::GetSelectedHandleProperty | ( |  | ) |
| virtual

Set/Get the handle properties (the spheres are the handles).

The properties of the handles when selected and unselected can be manipulated.

## ◆ GetLineProperty()

virtual vtkProperty* vtkCurveRepresentation::GetLineProperty | ( |  | ) |
| virtual

Set/Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ GetSelectedLineProperty()

virtual vtkProperty* vtkCurveRepresentation::GetSelectedLineProperty | ( |  | ) |
| virtual

Set/Get the line properties.

The properties of the line when selected and unselected can be manipulated.

## ◆ SetNumberOfHandles()

virtual void vtkCurveRepresentation::SetNumberOfHandles | ( | int | npts | ) |
| pure virtual

Set/Get the number of handles for this widget.

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ GetNumberOfHandles()

virtual int vtkCurveRepresentation::GetNumberOfHandles | ( |  | ) |
| virtual

Set/Get the number of handles for this widget.

## ◆ SetDirectional()

virtual void vtkCurveRepresentation::SetDirectional | ( | bool | val | ) |
| virtual

Set the representation to be directional or not.

The meaning of being directional depends on the representation and its handles implementations in the subclasses.

Reimplemented in vtkCameraPathRepresentation.

## ◆ GetDirectional()

virtual bool vtkCurveRepresentation::GetDirectional | ( |  | ) |
| virtual

Set the representation to be directional or not.

The meaning of being directional depends on the representation and its handles implementations in the subclasses.

## ◆ DirectionalOn()

virtual void vtkCurveRepresentation::DirectionalOn | ( |  | ) |
| virtual

Set the representation to be directional or not.

The meaning of being directional depends on the representation and its handles implementations in the subclasses.

## ◆ DirectionalOff()

virtual void vtkCurveRepresentation::DirectionalOff | ( |  | ) |
| virtual

Set the representation to be directional or not.

The meaning of being directional depends on the representation and its handles implementations in the subclasses.

## ◆ SetHandlePosition() [1/2]

virtual void vtkCurveRepresentation::SetHandlePosition | ( | int | handle,
|  | double | x,
|  | double | y,
|  | double | z
| ) |  |
| virtual

Set/Get the position of the handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ SetHandlePosition() [2/2]

virtual void vtkCurveRepresentation::SetHandlePosition | ( | int | handle,
|  | double | xyz[3]
| ) |  |
| virtual

Set/Get the position of the handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ GetHandlePosition() [1/2]

virtual void vtkCurveRepresentation::GetHandlePosition | ( | int | handle,
|  | double | xyz[3]
| ) |  |
| virtual

Set/Get the position of the handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ GetHandlePosition() [2/2]

virtual double* vtkCurveRepresentation::GetHandlePosition | ( | int | handle | ) |
| virtual

Set/Get the position of the handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

## ◆ GetHandlePositions()

virtual vtkDoubleArray* vtkCurveRepresentation::GetHandlePositions | ( |  | ) |
| pure virtual

Set/Get the position of the handles.

Call GetNumberOfHandles to determine the valid range of handle indices.

Implemented in vtkPolyLineRepresentation, and vtkAbstractSplineRepresentation.

## ◆ SetClosed()

void vtkCurveRepresentation::SetClosed | ( | vtkTypeBool | closed | ) |

Control whether the curve is open or closed.

A closed forms a continuous loop: the first and last points are the same. A minimum of 3 handles are required to form a closed loop.

## ◆ GetClosed()

virtual vtkTypeBool vtkCurveRepresentation::GetClosed | ( |  | ) |
| virtual

Control whether the curve is open or closed.

A closed forms a continuous loop: the first and last points are the same. A minimum of 3 handles are required to form a closed loop.

## ◆ ClosedOn()

virtual void vtkCurveRepresentation::ClosedOn | ( |  | ) |
| virtual

Control whether the curve is open or closed.

A closed forms a continuous loop: the first and last points are the same. A minimum of 3 handles are required to form a closed loop.

## ◆ ClosedOff()

virtual void vtkCurveRepresentation::ClosedOff | ( |  | ) |
| virtual

Control whether the curve is open or closed.

A closed forms a continuous loop: the first and last points are the same. A minimum of 3 handles are required to form a closed loop.

## ◆ IsClosed()

vtkTypeBool vtkCurveRepresentation::IsClosed | ( |  | ) |

Convenience method to determine whether the curve is closed in a geometric sense.

The widget may be set "closed" but still be geometrically open (e.g., a straight line).

## ◆ GetSummedLength()

virtual double vtkCurveRepresentation::GetSummedLength | ( |  | ) |
| pure virtual

Get the approximate vs.

the true arc length of the curve. Calculated as the summed lengths of the individual straight line segments. Use SetResolution to control the accuracy.

Implemented in vtkPolyLineRepresentation, and vtkAbstractSplineRepresentation.

## ◆ InitializeHandles()

virtual void vtkCurveRepresentation::InitializeHandles | ( | vtkPoints * | points | ) |
| pure virtual

Convenience method to allocate and set the handles from a vtkPoints instance.

If the first and last points are the same, the curve sets Closed to the on InteractionState and disregards the last point, otherwise Closed remains unchanged.

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ BuildRepresentation()

void vtkCurveRepresentation::BuildRepresentation | ( |  | ) |
| overridepure virtual

These are methods that satisfy vtkWidgetRepresentation API.

Note that a version of place widget is available where the center and handle position are specified.

Implements vtkWidgetRepresentation.

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ ComputeInteractionState()

int vtkCurveRepresentation::ComputeInteractionState | ( | int | X,
|  | int | Y,
|  | int | modify = `0`
| ) |  |
| overridevirtual

These are methods that satisfy vtkWidgetRepresentation API.

Note that a version of place widget is available where the center and handle position are specified.

Reimplemented from vtkWidgetRepresentation.

## ◆ StartWidgetInteraction()

void vtkCurveRepresentation::StartWidgetInteraction | ( | double | e[2] | ) |
| overridevirtual

These are methods that satisfy vtkWidgetRepresentation API.

Note that a version of place widget is available where the center and handle position are specified.

Reimplemented from vtkWidgetRepresentation.

## ◆ WidgetInteraction()

void vtkCurveRepresentation::WidgetInteraction | ( | double | e[2] | ) |
| overridevirtual

These are methods that satisfy vtkWidgetRepresentation API.

Note that a version of place widget is available where the center and handle position are specified.

Reimplemented from vtkWidgetRepresentation.

## ◆ EndWidgetInteraction()

void vtkCurveRepresentation::EndWidgetInteraction | ( | double | e[2] | ) |
| overridevirtual

These are methods that satisfy vtkWidgetRepresentation API.

Note that a version of place widget is available where the center and handle position are specified.

Reimplemented from vtkWidgetRepresentation.

## ◆ GetBounds()

double* vtkCurveRepresentation::GetBounds | ( |  | ) |
| overridevirtual

These are methods that satisfy vtkWidgetRepresentation API.

Note that a version of place widget is available where the center and handle position are specified.

Reimplemented from vtkProp.

## ◆ ReleaseGraphicsResources()

void vtkCurveRepresentation::ReleaseGraphicsResources | ( | vtkWindow * |  | ) |
| overridevirtual

Methods supporting, and required by, the rendering process.

Reimplemented from vtkProp.

## ◆ RenderOpaqueGeometry()

int vtkCurveRepresentation::RenderOpaqueGeometry | ( | vtkViewport * |  | ) |
| overridevirtual

Methods supporting, and required by, the rendering process.

Reimplemented from vtkProp.

## ◆ RenderTranslucentPolygonalGeometry()

int vtkCurveRepresentation::RenderTranslucentPolygonalGeometry | ( | vtkViewport * |  | ) |
| overridevirtual

Methods supporting, and required by, the rendering process.

Reimplemented from vtkProp.

## ◆ RenderOverlay()

int vtkCurveRepresentation::RenderOverlay | ( | vtkViewport * |  | ) |
| overridevirtual

Methods supporting, and required by, the rendering process.

Reimplemented from vtkProp.

## ◆ HasTranslucentPolygonalGeometry()

vtkTypeBool vtkCurveRepresentation::HasTranslucentPolygonalGeometry | ( |  | ) |
| overridevirtual

Methods supporting, and required by, the rendering process.

Reimplemented from vtkProp.

## ◆ SetLineColor()

void vtkCurveRepresentation::SetLineColor | ( | double | r,
|  | double | g,
|  | double | b
| ) |  |

Convenience method to set the line color.

Ideally one should use GetLineProperty()->SetColor().

## ◆ SetInteractionColor() [1/2]

void vtkCurveRepresentation::SetInteractionColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |

Set the color when unselected and selected.

## ◆ SetInteractionColor() [2/2]

void vtkCurveRepresentation::SetInteractionColor | ( | double | c[3] | ) |
| inline

Set the color when unselected and selected.

Definition at line 240 of file vtkCurveRepresentation.h.

## ◆ SetForegroundColor() [1/2]

void vtkCurveRepresentation::SetForegroundColor | ( | double | ,
|  | double | ,
|  | double |
| ) |  |

Set the color when unselected and selected.

## ◆ SetForegroundColor() [2/2]

void vtkCurveRepresentation::SetForegroundColor | ( | double | c[3] | ) |
| inline

Set the color when unselected and selected.

Definition at line 242 of file vtkCurveRepresentation.h.

## ◆ RegisterPickers()

void vtkCurveRepresentation::RegisterPickers | ( |  | ) |
| overridevirtual

Register internal Pickers in the Picking Manager.

Must be reimplemented by concrete widget representations to register their pickers.

Reimplemented from vtkWidgetRepresentation.

## ◆ SetCurrentHandleIndex()

void vtkCurveRepresentation::SetCurrentHandleIndex | ( | int | index | ) |

Get/Set the current handle index.

Setting the current handle index will also result in the handle being highlighted. Set to `-1` to remove the highlight.

## ◆ GetCurrentHandleIndex()

virtual int vtkCurveRepresentation::GetCurrentHandleIndex | ( |  | ) |
| virtual

Get/Set the current handle index.

Setting the current handle index will also result in the handle being highlighted. Set to `-1` to remove the highlight.

## ◆ GetTranslationAxis()

virtual int vtkCurveRepresentation::GetTranslationAxis | ( |  | ) |
| virtual

Gets/Sets the constraint axis for translations.

Returns Axis::NONE if none.

## ◆ SetTranslationAxis()

virtual void vtkCurveRepresentation::SetTranslationAxis | ( | int |  | ) |
| virtual

Gets/Sets the constraint axis for translations.

Returns Axis::NONE if none.

## ◆ SetXTranslationAxisOn()

void vtkCurveRepresentation::SetXTranslationAxisOn | ( |  | ) |
| inline

Toggles constraint translation axis on/off.

Definition at line 273 of file vtkCurveRepresentation.h.

## ◆ SetYTranslationAxisOn()

void vtkCurveRepresentation::SetYTranslationAxisOn | ( |  | ) |
| inline

Toggles constraint translation axis on/off.

Definition at line 274 of file vtkCurveRepresentation.h.

## ◆ SetZTranslationAxisOn()

void vtkCurveRepresentation::SetZTranslationAxisOn | ( |  | ) |
| inline

Toggles constraint translation axis on/off.

Definition at line 275 of file vtkCurveRepresentation.h.

## ◆ SetTranslationAxisOff()

void vtkCurveRepresentation::SetTranslationAxisOff | ( |  | ) |
| inline

Toggles constraint translation axis on/off.

Definition at line 276 of file vtkCurveRepresentation.h.

## ◆ IsTranslationConstrained()

bool vtkCurveRepresentation::IsTranslationConstrained | ( |  | ) |
| inline

Returns true if ConstrainedAxis.

Definition at line 283 of file vtkCurveRepresentation.h.

## ◆ GetActors()

void vtkCurveRepresentation::GetActors | ( | vtkPropCollection * |  | ) |
| overridevirtual

Methods to make this class behave as a vtkProp.

They are repeated here (from the vtkProp superclass) as a reminder to the widget implementor. Failure to implement these methods properly may result in the representation not appearing in the scene (i.e., not implementing the Render() methods properly) or leaking graphics resources (i.e., not implementing ReleaseGraphicsResources() properly).

Reimplemented from vtkProp.

## ◆ ProjectPointsToPlane()

void vtkCurveRepresentation::ProjectPointsToPlane | ( |  | ) |
| protected

## ◆ ProjectPointsToOrthoPlane()

void vtkCurveRepresentation::ProjectPointsToOrthoPlane | ( |  | ) |
| protected

## ◆ ProjectPointsToObliquePlane()

void vtkCurveRepresentation::ProjectPointsToObliquePlane | ( |  | ) |
| protected

## ◆ HighlightLine()

void vtkCurveRepresentation::HighlightLine | ( | int | highlight | ) |
| protected

## ◆ HighlightHandle()

int vtkCurveRepresentation::HighlightHandle | ( | vtkProp * | prop | ) |
| protected

## ◆ GetHandleActor()

virtual vtkActor* vtkCurveRepresentation::GetHandleActor | ( | int | index | ) |
| protectedpure virtual

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ GetHandleSource()

virtual vtkHandleSource* vtkCurveRepresentation::GetHandleSource | ( | int | index | ) |
| protectedpure virtual

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ GetHandleIndex()

virtual int vtkCurveRepresentation::GetHandleIndex | ( | vtkProp * | prop | ) |
| protectedpure virtual

returns handle index or -1 on fail

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ SizeHandles()

virtual void vtkCurveRepresentation::SizeHandles | ( |  | ) |
| protectedvirtual

Reimplemented in vtkCameraPathRepresentation.

## ◆ InsertHandleOnLine()

virtual int vtkCurveRepresentation::InsertHandleOnLine | ( | double * | pos | ) |
| protectedpure virtual

Returns the position of insertion or -1 on fail.

Implemented in vtkSplineRepresentation, vtkPolyLineRepresentation, and vtkCameraPathRepresentation.

## ◆ PushHandle()

virtual void vtkCurveRepresentation::PushHandle | ( | double * | pos | ) |
| protectedvirtual

## ◆ EraseHandle()

virtual void vtkCurveRepresentation::EraseHandle | ( | const int & |  | ) |
| protectedvirtual

Reimplemented in vtkCameraPathRepresentation.

## ◆ MovePoint()

void vtkCurveRepresentation::MovePoint | ( | double * | p1,
|  | double * | p2
| ) |  |
| protected

## ◆ Scale()

void vtkCurveRepresentation::Scale | ( | double * | p1,
|  | double * | p2,
|  | int | X,
|  | int | Y
| ) |  |
| protected

## ◆ Translate()

void vtkCurveRepresentation::Translate | ( | double * | p1,
|  | double * | p2
| ) |  |
| protected

## ◆ Spin()

void vtkCurveRepresentation::Spin | ( | double * | p1,
|  | double * | p2,
|  | double * | vpn
| ) |  |
| protected

## ◆ CreateDefaultProperties()

void vtkCurveRepresentation::CreateDefaultProperties | ( |  | ) |
| protected

## ◆ CalculateCentroid()

void vtkCurveRepresentation::CalculateCentroid | ( |  | ) |
| protected

## Member Data Documentation

## ◆ LastEventPosition

double vtkCurveRepresentation::LastEventPosition[3]
| protected

Definition at line 299 of file vtkCurveRepresentation.h.

## ◆ Bounds

double vtkCurveRepresentation::Bounds[6]
| protected

Definition at line 300 of file vtkCurveRepresentation.h.

## ◆ ProjectionNormal

int vtkCurveRepresentation::ProjectionNormal
| protected

Definition at line 303 of file vtkCurveRepresentation.h.

## ◆ ProjectionPosition

double vtkCurveRepresentation::ProjectionPosition
| protected

Definition at line 304 of file vtkCurveRepresentation.h.

## ◆ ProjectToPlane

vtkTypeBool vtkCurveRepresentation::ProjectToPlane
| protected

Definition at line 305 of file vtkCurveRepresentation.h.

## ◆ PlaneSource

vtkPlaneSource* vtkCurveRepresentation::PlaneSource
| protected

Definition at line 306 of file vtkCurveRepresentation.h.

## ◆ NumberOfHandles

int vtkCurveRepresentation::NumberOfHandles = 0
| protected

Definition at line 313 of file vtkCurveRepresentation.h.

## ◆ Closed

vtkTypeBool vtkCurveRepresentation::Closed
| protected

Definition at line 314 of file vtkCurveRepresentation.h.

## ◆ LineActor

vtkActor* vtkCurveRepresentation::LineActor
| protected

Definition at line 317 of file vtkCurveRepresentation.h.

## ◆ HandlePicker

vtkCellPicker* vtkCurveRepresentation::HandlePicker
| protected

Definition at line 340 of file vtkCurveRepresentation.h.

## ◆ LinePicker

vtkCellPicker* vtkCurveRepresentation::LinePicker
| protected

Definition at line 341 of file vtkCurveRepresentation.h.

## ◆ LastPickPosition

double vtkCurveRepresentation::LastPickPosition[3]
| protected

Definition at line 342 of file vtkCurveRepresentation.h.

## ◆ CurrentHandle

vtkActor* vtkCurveRepresentation::CurrentHandle
| protected

Definition at line 343 of file vtkCurveRepresentation.h.

## ◆ CurrentHandleIndex

int vtkCurveRepresentation::CurrentHandleIndex
| protected

Definition at line 344 of file vtkCurveRepresentation.h.

## ◆ FirstSelected

bool vtkCurveRepresentation::FirstSelected
| protected

Definition at line 345 of file vtkCurveRepresentation.h.

## ◆ Transform

vtkTransform* vtkCurveRepresentation::Transform
| protected

Definition at line 354 of file vtkCurveRepresentation.h.

## ◆ Directional

bool vtkCurveRepresentation::Directional = false
| protected

Definition at line 357 of file vtkCurveRepresentation.h.

## ◆ HandleProperty

vtkProperty* vtkCurveRepresentation::HandleProperty
| protected

Definition at line 361 of file vtkCurveRepresentation.h.

## ◆ SelectedHandleProperty

vtkProperty* vtkCurveRepresentation::SelectedHandleProperty
| protected

Definition at line 362 of file vtkCurveRepresentation.h.

## ◆ LineProperty

vtkProperty* vtkCurveRepresentation::LineProperty
| protected

Definition at line 363 of file vtkCurveRepresentation.h.

## ◆ SelectedLineProperty

vtkProperty* vtkCurveRepresentation::SelectedLineProperty
| protected

Definition at line 364 of file vtkCurveRepresentation.h.

## ◆ Centroid

double vtkCurveRepresentation::Centroid[3]
| protected

Definition at line 368 of file vtkCurveRepresentation.h.

## ◆ TranslationAxis

int vtkCurveRepresentation::TranslationAxis
| protected

Definition at line 371 of file vtkCurveRepresentation.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkCurveRepresentation.h